/**
 * test program of printing float with PSoC 4
 * Using UART_UartPutString() with "%d"
 */

#include "project.h"
#include <stdio.h>   

char str[128] ; /* print buf */

int main(void) 
{
    char sign = ' ' ;
    float f_value = 18.315 ;

    CyGlobalIntEnable;

    UART_Start();
   
    sprintf(str,"print float test using %%d (%s %s)\r\n", __DATE__, __TIME__);   
    UART_UartPutString(str) ;
    UART_UartPutString("printing 18.315 in %%.2f style\r\n") ;

    UART_UartPutString("first the simplest case, no rounding\r\n") ;
    sprintf(str, "%d.%02d\r\n", (int)f_value, ((int)(f_value * 100))%100) ; 
    UART_UartPutString(str) ;
    
    UART_UartPutString("second case, with rounding\r\n") ;
    sprintf(str, "%d.%02d\r\n", (int)(f_value + 0.005), ((int)(f_value * 100.0 + 0.5))%100);
    UART_UartPutString(str) ;

    UART_UartPutString("third case, when value can be negative with rounding\r\n") ;

    f_value = -18.315 ; // making f_value as a negative value
    
    if (f_value < 0.0) {
        sign = '-' ;
        f_value = -f_value ;
    }
    sprintf(str, "%c%d.%02d\r\n", sign, (int)(f_value + 0.005), ((int)(f_value * 100.0 + 0.5))%100);
    UART_UartPutString(str);
   
    for(;;) {

   }   
}  

/* [] END OF FILE */
